diff --git a/auth/auth.go b/auth/auth.go
index 25ce52e..ddcafb6 100644
--- a/auth/auth.go
+++ b/auth/auth.go
@@ -9,24 +9,6 @@ import (
 	"net/http"
 )
 
-// Register a new user with the controller.
-// If controller registration is set to administrators only, a valid administrative
-// user token is required in the client.
-func Register(c *drycc.Client, username, password, email string) error {
-	user := api.AuthRegisterRequest{Username: username, Password: password, Email: email}
-	body, err := json.Marshal(user)
-
-	if err != nil {
-		return err
-	}
-
-	res, err := c.Request("POST", "/v2/auth/register/", body)
-	if err == nil {
-		res.Body.Close()
-	}
-	return err
-}
-
 // Login to the controller and get a oauth url
 func Login(c *drycc.Client) (string, error) {
 	c.HTTPClient.CheckRedirect = func(req *http.Request, via []*http.Request) error {
@@ -58,96 +40,6 @@ func Token(c *drycc.Client, key string) (api.AuthLoginResponse, error) {
 	return token, reqErr
 }
 
-// Delete deletes a user.
-func Delete(c *drycc.Client, username string) error {
-	var body []byte
-	var err error
-
-	if username != "" {
-		req := api.AuthCancelRequest{Username: username}
-		body, err = json.Marshal(req)
-
-		if err != nil {
-			return err
-		}
-	}
-
-	res, err := c.Request("DELETE", "/v2/auth/cancel/", body)
-	if err == nil {
-		res.Body.Close()
-	}
-	return err
-}
-
-// Regenerate auth tokens. This invalidates existing tokens, and if targeting a specific user
-// returns a new token.
-//
-// If username is an empty string and all is false, this regenerates the
-// client user's token and will return a new token. Make sure to update the client token
-// with this new token to avoid authentication errors.
-//
-// If username is set and all is false, this will regenerate that user's token
-// and return a new token. If not targeting yourself, regenerate requires administrative privileges.
-//
-// If all is true, this will regenerate every user's token. This requires administrative privileges.
-func Regenerate(c *drycc.Client, username string, all bool) (string, error) {
-	var reqBody []byte
-	var err error
-
-	if all {
-		reqBody, err = json.Marshal(api.AuthRegenerateRequest{All: all})
-	} else if username != "" {
-		reqBody, err = json.Marshal(api.AuthRegenerateRequest{Name: username})
-	}
-
-	if err != nil {
-		return "", err
-	}
-
-	res, reqErr := c.Request("POST", "/v2/auth/tokens/", reqBody)
-	if reqErr != nil && !drycc.IsErrAPIMismatch(reqErr) {
-		return "", reqErr
-	}
-	defer res.Body.Close()
-
-	if all {
-		return "", nil
-	}
-
-	token := api.AuthRegenerateResponse{}
-	if err = json.NewDecoder(res.Body).Decode(&token); err != nil {
-		return "", err
-	}
-
-	return token.Token, reqErr
-}
-
-// Passwd changes a user's password.
-//
-// If username if an empty string, change the password of the client's user.
-//
-// If username is set, change the password of another user and do not require
-// their password. This requires administrative privileges.
-func Passwd(c *drycc.Client, username, password, newPassword string) error {
-	req := api.AuthPasswdRequest{Password: password, NewPassword: newPassword}
-
-	if username != "" {
-		req.Username = username
-	}
-
-	body, err := json.Marshal(req)
-
-	if err != nil {
-		return err
-	}
-
-	res, err := c.Request("POST", "/v2/auth/passwd/", body)
-	if err == nil {
-		res.Body.Close()
-	}
-	return err
-}
-
 // Whoami retrives the user object for the authenticated user.
 func Whoami(c *drycc.Client) (api.User, error) {
 	res, err := c.Request("GET", "/v2/auth/whoami/", nil)
diff --git a/auth/auth_test.go b/auth/auth_test.go
index c7b48cc..26f4d54 100644
--- a/auth/auth_test.go
+++ b/auth/auth_test.go
@@ -3,7 +3,6 @@ package auth
 import (
 	"fmt"
 	"github.com/drycc/controller-sdk-go/api"
-	"io/ioutil"
 	"net/http"
 	"net/http/httptest"
 	"testing"
@@ -11,13 +10,6 @@ import (
 	drycc "github.com/drycc/controller-sdk-go"
 )
 
-const registerExpected string = `{"username":"test","password":"opensesame","email":"test@example.com"}`
-const passwdExpected string = `{"username":"test","password":"old","new_password":"new"}`
-const regenAllExpected string = `{"all":true}`
-const regenUserExpected string = `{"username":"test"}`
-const cancelUserExpected string = `{"username":"foo"}`
-const cancelAdminExpected string = `{"username":"admin"}`
-
 type fakeHTTPServer struct {
 	regenBodyEmpty    bool
 	regenBodyAll      bool
@@ -29,27 +21,6 @@ type fakeHTTPServer struct {
 func (f *fakeHTTPServer) ServeHTTP(res http.ResponseWriter, req *http.Request) {
 	res.Header().Add("DRYCC_API_VERSION", drycc.APIVersion)
 
-	if req.URL.Path == "/v2/auth/register/" && req.Method == "POST" {
-		body, err := ioutil.ReadAll(req.Body)
-
-		if err != nil {
-			fmt.Println(err)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-		}
-
-		if string(body) != registerExpected {
-			fmt.Printf("Expected '%s', Got '%s'\n", registerExpected, body)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-			return
-		}
-
-		res.WriteHeader(http.StatusCreated)
-		res.Write(nil)
-		return
-	}
-
 	if req.URL.Path == "/v2/auth/login/" && req.Method == "POST" {
 		res.Header().Add("Location", "/v2/login/drycc/?key=fdbf3b34742e4ed2be4dfa848af13007/")
 		res.WriteHeader(http.StatusFound)
@@ -63,110 +34,11 @@ func (f *fakeHTTPServer) ServeHTTP(res http.ResponseWriter, req *http.Request) {
 		return
 	}
 
-	if req.URL.Path == "/v2/auth/passwd/" && req.Method == "POST" {
-		body, err := ioutil.ReadAll(req.Body)
-
-		if err != nil {
-			fmt.Println(err)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-		}
-
-		if string(body) != passwdExpected {
-			fmt.Printf("Expected '%s', Got '%s'\n", passwdExpected, body)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-			return
-		}
-
-		res.Write(nil)
-		res.WriteHeader(http.StatusInternalServerError)
-		return
-	}
-
-	if req.URL.Path == "/v2/auth/tokens/" && req.Method == "POST" {
-		body, err := ioutil.ReadAll(req.Body)
-
-		if err != nil {
-			fmt.Println(err)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-		}
-
-		if string(body) == regenAllExpected && !f.regenBodyAll {
-			f.regenBodyAll = true
-			res.Write(nil)
-			return
-		} else if string(body) == regenUserExpected && !f.regenBodyUsername {
-			f.regenBodyUsername = true
-			res.Write([]byte(`{"token":"123"}`))
-			return
-		} else if string(body) == "" && !f.regenBodyEmpty {
-			f.regenBodyEmpty = true
-			res.Write([]byte(`{"token":"abc"}`))
-			return
-		}
-
-		fmt.Printf("%s is not a valid body.", body)
-		res.WriteHeader(http.StatusInternalServerError)
-		res.Write(nil)
-		return
-	}
-
-	if req.URL.Path == "/v2/auth/cancel/" && req.Method == "DELETE" {
-		body, err := ioutil.ReadAll(req.Body)
-
-		if err != nil {
-			fmt.Println(err)
-			res.WriteHeader(http.StatusInternalServerError)
-			res.Write(nil)
-		}
-
-		if string(body) == cancelAdminExpected && !f.cancelUsername {
-			f.cancelUsername = true
-			res.WriteHeader(http.StatusConflict)
-			res.Write([]byte(`{"detail":"foo still has applications assigned. Delete or transfer ownership"}`))
-			return
-		} else if string(body) == cancelUserExpected && !f.cancelUsername {
-			f.cancelUsername = true
-			res.WriteHeader(http.StatusNoContent)
-			res.Write(nil)
-			return
-		} else if string(body) == "" && !f.cancelEmpty {
-			f.cancelEmpty = true
-			res.WriteHeader(http.StatusNoContent)
-			res.Write(nil)
-			return
-		}
-
-		fmt.Printf("%s is not a valid body.", body)
-		res.WriteHeader(http.StatusInternalServerError)
-		res.Write(nil)
-		return
-	}
-
 	fmt.Printf("Unrecognized URL %s\n", req.URL)
 	res.WriteHeader(http.StatusNotFound)
 	res.Write(nil)
 }
 
-func TestRegister(t *testing.T) {
-	t.Parallel()
-
-	handler := fakeHTTPServer{}
-	server := httptest.NewServer(&handler)
-	defer server.Close()
-
-	drycc, err := drycc.New(false, server.URL, "abc")
-	if err != nil {
-		t.Fatal(err)
-	}
-
-	if err = Register(drycc, "test", "opensesame", "test@example.com"); err != nil {
-		t.Error(err)
-	}
-}
-
 func TestLogin(t *testing.T) {
 	t.Parallel()
 
@@ -217,106 +89,3 @@ func TestToken(t *testing.T) {
 		t.Errorf("Expected %s, Got %s", expected, token)
 	}
 }
-
-func TestPasswd(t *testing.T) {
-	t.Parallel()
-
-	handler := fakeHTTPServer{}
-	server := httptest.NewServer(&handler)
-	defer server.Close()
-
-	drycc, err := drycc.New(false, server.URL, "abc")
-	if err != nil {
-		t.Fatal(err)
-	}
-
-	if err := Passwd(drycc, "test", "old", "new"); err != nil {
-		t.Error(err)
-	}
-}
-
-func TestDelete(t *testing.T) {
-	t.Parallel()
-
-	handler := fakeHTTPServer{cancelUsername: false, cancelEmpty: false}
-	server := httptest.NewServer(&handler)
-	defer server.Close()
-
-	drycc, err := drycc.New(false, server.URL, "abc")
-	if err != nil {
-		t.Fatal(err)
-	}
-
-	if err := Delete(drycc, "foo"); err != nil {
-		t.Error(err)
-	}
-
-	if err := Delete(drycc, ""); err != nil {
-		t.Error(err)
-	}
-}
-
-func TestDeleteUserApp(t *testing.T) {
-	t.Parallel()
-
-	handler := fakeHTTPServer{cancelUsername: false, cancelEmpty: false}
-	server := httptest.NewServer(&handler)
-	defer server.Close()
-
-	d, err := drycc.New(false, server.URL, "abc")
-	if err != nil {
-		t.Fatal(err)
-	}
-
-	err = Delete(d, "admin")
-	// should be a 409 Conflict
-
-	if err != drycc.ErrCancellationFailed {
-		t.Errorf("got '%s' but expected '%s'", err, drycc.ErrConflict)
-	}
-}
-
-func TestRegenerate(t *testing.T) {
-	t.Parallel()
-
-	handler := fakeHTTPServer{}
-	server := httptest.NewServer(&handler)
-	defer server.Close()
-
-	drycc, err := drycc.New(false, server.URL, "abc")
-	if err != nil {
-		t.Fatal(err)
-	}
-
-	token, err := Regenerate(drycc, "", true)
-
-	if err != nil {
-		t.Error(err)
-	}
-
-	if token != "" {
-		t.Errorf("Expected token be empty, Got %s", token)
-	}
-
-	token, err = Regenerate(drycc, "test", false)
-
-	if err != nil {
-		t.Error(err)
-	}
-
-	expected := "123"
-	if token != expected {
-		t.Errorf("Expected %s, Got %s", expected, token)
-	}
-
-	token, err = Regenerate(drycc, "", false)
-
-	if err != nil {
-		t.Error(err)
-	}
-
-	expected = "abc"
-	if token != expected {
-		t.Errorf("Expected %s, Got %s", expected, token)
-	}
-}